import java.rmi.RemoteException;
import java.rmi.server.UnicastRemoteObject;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Properties;
import java.util.Set;


public class Score extends UnicastRemoteObject implements Iscore {

	private static final long serialVersionUID = 1L;
	private ArrayList<String> s = new ArrayList<String>();
	private Start father;

	//on recupere la conf, on la memorise dans une liste
	public Score(Properties conf,Start pere) throws RemoteException {
		super();
		father = pere;
		int i = 0;
		String tmp = conf.getProperty("SCORE"+i);
		while(tmp!=null){
			s.add(tmp);
			i++;
			tmp = conf.getProperty("SCORE"+i);
		}
	}

	@Override
	public ArrayList<String> getList() throws RemoteException{
		return s;
	}

	@Override
	public void send(String name, int score) throws RemoteException {
		if(name.length()>0){
			father.pop("nouveau score de "+score+" pour "+name+" !");
			s.add(name+":"+score);
			sort();
		}
	}

	// on tris les scores et on regenere la liste
	private void sort(){
		HashMap<String,Integer> names = new HashMap<String,Integer>();
		String[] parsed;
		for(String line : s){
			parsed = line.split(":");
			if(names.containsKey(parsed[0])){
				//si la clef existe deja on prend la plus grande
				if(names.get(parsed[0])<Integer.parseInt(parsed[1]))
					names.put(parsed[0], Integer.parseInt(parsed[1]));
			}
			else
			names.put(parsed[0], Integer.parseInt(parsed[1]));
		}
		s.clear();
		Set<String> keys = names.keySet();
		int size = keys.size();
		int max = 0;
		int current;
		String maxName = null;
		for( int i = 0; i<size; i++)
		{
			keys = names.keySet();
			max = 0;
			for(String k : keys){
				if(maxName == null)
					maxName = k;
				current =names.get(k);
				if(current>max){
					max = current;
					maxName = k;
				}
			}
			names.remove(maxName);
			if(max>0)
				s.add(maxName+":"+max);
		}
	}


}
