import java.awt.Color;
import java.awt.FlowLayout;
import java.awt.Window;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.net.MalformedURLException;
import java.rmi.Naming;
import java.rmi.NotBoundException;
import java.rmi.RemoteException;
import java.util.ArrayList;

import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;


public class ScoreDlg extends JDialog implements ActionListener{

	private static final long serialVersionUID = 1L;
	private Iscore score;
	private int value = 0;
	JTextField t;
	
	public ScoreDlg(Window owner, int ScoreValue) throws MalformedURLException, RemoteException, NotBoundException{
		//configuration de base
		super(owner);
		value = ScoreValue;
		this.setTitle("Score : "+ScoreValue);
		this.setDefaultCloseOperation(DISPOSE_ON_CLOSE);
		this.setResizable(false);
		this.rootPane.setLayout(new BoxLayout(this.rootPane,BoxLayout.Y_AXIS));
		this.rootPane.setLayout(new FlowLayout());
		//this.rootPane.setLayout(new BoxLayout(this.rootPane,BoxLayout.PAGE_AXIS));
		this.rootPane.setBackground(Color.white);
		this.rootPane.add(Box.createHorizontalGlue());
		
		//on recupere la classe rmi
		System.out.println("connexion a "+MainWin.url );
		score = (Iscore) Naming.lookup("rmi://"+MainWin.url+"/Score");
		
		//on continu la creation de la fenetre
		JButton b = new JButton("Envoyer");
		t=new JTextField(10);
		JPanel p = new JPanel();
		p.setBackground(Color.white);
		p.setLayout(new FlowLayout());
		p.add(t);
		p.add(b);
		this.rootPane.add(p);
		b.addActionListener(this);
		
		//on ajoute la liste de score
		ArrayList<String > list = score.getList();
		String[] table;
		for(String s : list)
		{
			table = s.split(":");
			this.rootPane.add(new JLabel("     "+table[0].trim()+"  :  "+table[1]+"           "));
		}
		
		this.setAlwaysOnTop(true);
		this.setModal(true);
		this.setSize(220, 16*list.size()+128);
		this.validate();
		this.setVisible(true);
	}

	@Override
	public void actionPerformed(ActionEvent arg0) {
		if(arg0.getActionCommand().equals("Envoyer"))
			try {
				score.send(t.getText(), value);
			} catch (RemoteException e) {
				e.printStackTrace();
			}
			this.setVisible(false);
	}	

}
